class Zelle
{

  //--------------------------------------------------------------------------------------------------
  // Variabeln
  //--------------------------------------------------------------------------------------------------

  boolean fertig;
  int AnzahlBeruehrungen = 0;                          // effektive Anzahl Berhrungen
  int Beruehrungszaehler = 0;                          // wird bei jedem Durchgang auf null gesetzt und von Neuem hochgezhlt        
  float [] Beruehrungspunkt = new float [4];           // von den max. 2 Berhrungspunkten werden die Koordinaten gespeichert
  color col;
  float xZelle;
  float yZelle;
  float rZelle;

  //--------------------------------------------------------------------------------------------------
  // Konstruktoren
  //--------------------------------------------------------------------------------------------------

  Zelle ()                                              // Konstruktor ohne Parametereingabe                
  {
    fertig = false;
    col = c3;
    int [] Position = freieStelle ();
    xZelle = Position [0];
    yZelle = Position [1];
    rZelle = 0;
  }


  //--------------------------------------------------------------------------------------------------
  // Methoden
  //--------------------------------------------------------------------------------------------------

  void entwickeln ()                                      // lsst die Zellen wachsen und verschiebt sie gegebenenfalls (gem. Anz Berhrungen) 
  {
      if (getFertig () == false)                          // falls die Zelle noch nicht fertig ist
      {
        int Beruehrungen = BeruehrungenZaehlen ();        // Zelle testen
        
        switch (Beruehrungen) {
          
          case 0:                                         // keine Berhrung -> wachsen
            wachsen();
            break;
            
          case 1:                                         // 1 Berhrung -> bewegen, wachsen
            loeschen();
            bewegen_Ber_1();
            wachsen();
            break;
            
          case 2:                                         // 2 Berhrung -> bewegen, wachsen
            loeschen();
            bewegen_Ber_2();
            wachsen();
            break;
            
          default:                                        // 3 oder mehr Berhrungen
            if (getGeometrie () [2] < minR) {             // wird neu gestartet, falls sie fertig, aber zu klein ist
              reset ();          
            } else {                                      // Zelle wird als "fertig" deklariert
              setFertig (true);
            }
            break;  
        }
      }
  }

  //--------------------------------------------------------------------------------------------------
  
  void zeichnen ()
  {
    zeichne_Kreis (xZelle, yZelle, rZelle, col);
  }

  //--------------------------------------------------------------------------------------------------

  void loeschen ()
  {
    zeichne_Kreis (xZelle, yZelle, rZelle, Hintergrund);
  }

  //--------------------------------------------------------------------------------------------------

  void wachsen ()
  {
    rZelle += f;
    zeichnen ();
  }

  //--------------------------------------------------------------------------------------------------

  int BeruehrungenZaehlen ()                                                      // gibt die Anzahl Berhrungen der Zelle zurck
  {
    Beruehrungszaehler = 0;

  // Zellen

    for (int i=0; i<=n; i++)
    {
      float xNachbar = meineZelle [i].getGeometrie () [0];
      float yNachbar = meineZelle [i].getGeometrie () [1];
      float rNachbar = meineZelle [i].getGeometrie () [2];
      float Abstand = sqrt(sq(xNachbar - xZelle) + sq(yNachbar -yZelle));

      if (Abstand <= rZelle + minA + rNachbar && Abstand != 0)                                                          // Berhrung
      {
        setBerKoor (xZelle + (rZelle/Abstand)*(xNachbar - xZelle), yZelle + (rZelle/Abstand)*(yNachbar - yZelle));      // Koordinaten Berhrungspunkt setzen
      }
    }

  // ffnungen

    for (int i=0; i < AnzahlOeffnungen; i++)
    {
      float xL = meineOeffnung [i].getGeometrie () [0];
      float xR = meineOeffnung [i].getGeometrie () [1];
      float yO = meineOeffnung [i].getGeometrie () [2];
      float yU = meineOeffnung [i].getGeometrie () [3];

      if (yZelle <= yU + rZelle + minA && yZelle >= yO - rZelle -minA && xZelle <= xR + rZelle + minA && xZelle >= xL - rZelle -minA)    // nur schlaufen, falls Berhrung mglich
      {
        if (yZelle <= yU && yZelle >= yO) {             // Berhrung links oder rechts
          if (xZelle < xL) {                            // Berhrung links
            setBerKoor (xZelle + rZelle, yZelle);
          } 
          else if (xZelle > xR) {                       // Berhrung rechts
            setBerKoor (xZelle - rZelle, yZelle);
          }
        } 
        else if (xZelle <= xR && xZelle >= xL) {        // Berhrung oben oder unten
          if (yZelle < yO) {                            // Berhrung oben
            setBerKoor (xZelle, yZelle + rZelle);
          } 
          else if (yZelle > yU) {                       // Berhrung rechts
            setBerKoor (xZelle, yZelle - rZelle);
          }
        } 
        else {                                                                     // Berhrung an einer Ecke
          if (sqrt(sq(xL - xZelle) + sq(yU -yZelle)) <= rZelle + minA) {           // Berhrung unten links
            float Abstand = sqrt(sq(xL - xZelle) + sq(yU -yZelle));
            setBerKoor (xZelle + (rZelle/Abstand)*(xL - xZelle), yZelle + (rZelle/Abstand)*(yU - yZelle));
          } 
          else if (sqrt(sq(xR - xZelle) + sq(yU -yZelle)) <= rZelle + minA) {      // Berhrung unten rechts
            float Abstand = sqrt(sq(xR - xZelle) + sq(yU -yZelle));
            setBerKoor (xZelle + (rZelle/Abstand)*(xR - xZelle), yZelle + (rZelle/Abstand)*(yU - yZelle));
          } 
          else if (sqrt(sq(xR - xZelle) + sq(yO -yZelle)) <= rZelle + minA) {      // Berhrung oben rechts
            float Abstand = sqrt(sq(xR - xZelle) + sq(yO -yZelle));
            setBerKoor (xZelle + (rZelle/Abstand)*(xR - xZelle), yZelle + (rZelle/Abstand)*(yO - yZelle));
          } 
          else if (sqrt(sq(xL - xZelle) + sq(yO -yZelle)) <= rZelle + minA) {      // Berhrung oben links
            float Abstand = sqrt(sq(xL - xZelle) + sq(yO -yZelle));
            setBerKoor (xZelle + (rZelle/Abstand)*(xL - xZelle), yZelle + (rZelle/Abstand)*(yO - yZelle));
          }
        }
      }

    }

  // Rnder

    if (xZelle <= rZelle + minA) {                     // Berhrung links
      setBerKoor (xZelle - rZelle, yZelle);
    } if (xZelle >= width - rZelle - minA) {           // Berhrung rechts
      setBerKoor (xZelle + rZelle, yZelle);
    } if (yZelle <= rZelle + minA) {                   // Berhrung oben
      setBerKoor (xZelle, yZelle - rZelle);
    } if (yZelle >= height - rZelle - minA) {          // Berhrung unten
      setBerKoor (xZelle, yZelle + rZelle);
    }
    
    if (Beruehrungszaehler > AnzahlBeruehrungen)       // Variable AnzahlBerhrungen macht das hoch und runter des Berhrungszhlers nicht mit
    {
      AnzahlBeruehrungen = Beruehrungszaehler;
      setBeruehrungspunkt ();                          // ndert die zeichnen-Methode (neuer Kreis im Kreis)
    }
    return (Beruehrungszaehler);
  }

  //--------------------------------------------------------------------------------------------------

  void bewegen_Ber_1 ()                                                    // bewegen bei einer Berhrung
  {
    xZelle += g*(xZelle - Beruehrungspunkt [0])/rZelle;                    // Mittelpunkt verschieben
    yZelle += g*(yZelle - Beruehrungspunkt [1])/rZelle;
  }

  //--------------------------------------------------------------------------------------------------

  void bewegen_Ber_2 ()                                                    // bewegen bei zwei Berhrungen
  {
    float xMitte = (Beruehrungspunkt [0] + Beruehrungspunkt [2])/2;
    float yMitte = (Beruehrungspunkt [1] + Beruehrungspunkt [3])/2;
    float AbstandMitte = sqrt(sq(xMitte - xZelle) + sq(yMitte - yZelle));
    // float CosinusWinkel = AbstandMitte / rZelle;
    if (AbstandMitte > 0.1) {                                               // Rundungsungenauigkeiten vermeiden
      xZelle += g*((xZelle - xMitte)/AbstandMitte);                         // Mittelpunkt verschieben
      yZelle += g*((yZelle - yMitte)/AbstandMitte);
    } else {
      setFertig (true);
    }
  }

  //--------------------------------------------------------------------------------------------------

  void setBerKoor (float x, float y)                    // erhht den Berhrungszhler und schreibt die Koordinaten des Berhrungspunktes ins Array
  {
    Beruehrungszaehler++;
    if (Beruehrungszaehler<=2)
    {
      Beruehrungspunkt [Beruehrungszaehler*2-2] = x;    // x-Wert Berhrunspunkt
      Beruehrungspunkt [Beruehrungszaehler*2-1] = y;    // y-Wert Berhrunspunkt
    }
  }

  //--------------------------------------------------------------------------------------------------

  void reset ()                                    // setzt die Zelle zurck (Zelle wird "neu genereiert")
  {
    loeschen ();                                   // Zelle lschen

    fertig = false;                                // Variabeln zurcksetzen
    col = c3;
    int [] Position = freieStelle ();
    xZelle = Position [0];
    yZelle = Position [1];
    rZelle = 0;
  }

  //--------------------------------------------------------------------------------------------------

  boolean getFertig ()                                // Variable "fertig" auslesen     
  {
    return fertig;
  }  

  //--------------------------------------------------------------------------------------------------  

  float [] getGeometrie ()                            // Geometrie auslesen
  {
    float [] Geometrie = {
      xZelle, yZelle, rZelle    };
    return Geometrie;
  }  

  //--------------------------------------------------------------------------------------------------

  void setFertig (boolean f)                           // Variable "fertig" setzen und Zelle neu zeichnen
  {
    fertig = f;
    zeichnen ();
  }    

  // --------------------------------------------------------------------------------------------------

  void setFarbe (color c)                              // Methode: Farbe setzen
  {
    col = c;
  }    

  //--------------------------------------------------------------------------------------------------

  void setBeruehrungspunkt ()                          // wird in Unterklasse berdeckt
  {
    
  }    

  //--------------------------------------------------------------------------------------------------

}
